{
    volScalarField alpha3New = alpha3;

    int iter = 0;
    scalar residual = 1;
    scalar meanResidual = 1;

    do
    {
        iter++;

        alpha3 = alpha3New;
        alpha4 = scalar(1) - alpha3;
        cp = alpha3*cpl + alpha4*cps;
        phiCp = fvc::interpolate(cp)*phi;
        lambda = alpha3*lambdal + alpha4*lambdas;

        fvScalarMatrix TEqn
        (
            fvm::ddt(cp, T)
          + fvm::div(phiCp, T)
          + L*fvc::ddt(alpha3)
          + L*fvc::div(phi, alpha3)
          - Tmelt*fvc::ddt(cp)
          - Tmelt*fvc::div(phiCp)
          - fvm::laplacian(lambda/rho, T)
        );

        TEqn.relax();

        TEqn.solve();

        Tstar = (Tl-Ts)*alpha3+Ts;  
        alpha3New = max(min(alpha3+alpha3Rel*cp/L*(T-Tstar),scalar(1)),scalar(0));
        residual = gMax(mag(alpha3New.internalField()-alpha3.internalField()));
        meanResidual = gSum(mag(alpha3New.internalField()-alpha3.internalField())*mesh.V())/gSum(mesh.V().field());
          
        Info << "Correcting alpha3, mean residual = " << meanResidual
             << ", max residual = " << residual
             << endl;

    } while ((iter < minTCorr || residual > alpha3Tol ) && iter <= maxTCorr);

    #include "balance.H"

    mu = mu0*(scalar(1)-max(muk*(T-Tl),scalar(0)));
    DC = DCl*pow(alpha4,2)/(pow(alpha3,3)+DCs);
    rhok = scalar(1)-max(beta*(T-Tl),scalar(0));
}
