    const surfaceScalarField::GeometricBoundaryField& patchHeatFlux =
    heatFlux.boundaryField();

    forAll(patchHeatFlux, patchi)
    {
        if (isA<wallFvPatch>(mesh.boundary()[patchi]))
        {
            dimensionedScalar heatFluxPerWall(sum(patchHeatFlux[patchi]));

            Info<< "Wall heat flux "  << mesh.boundary()[patchi].name()
                << " [W] = " << heatFluxPerWall.value()
                << endl;
        }
    }

    energyInput = energyInput + gSum(heatFlux.boundaryField())*runTime.deltaT().value();

    Info<< "Total energy [J] = " << gSum(h)*gSum(mesh.V().field())
        << "  sensible [J] = " << gSum(hs)*gSum(mesh.V().field())
        << "  latent [J] = " << gSum(hl)*gSum(mesh.V().field())
        << endl;

    Info<< "Heat flux [W] = " << gSum(heatFlux.boundaryField())
        << "  energy input [J] = " << energyInput.value()
        << "  difference [J] = " << gSum(h)*gSum(mesh.V().field())-energyInput.value()
        << endl;
