   IOdictionary transportProperties
    (
        IOobject
        (
            "transportProperties",
            runTime.constant(),
            mesh,
            IOobject::MUST_READ,
            IOobject::NO_WRITE
        )
    );

    // Reading density rho
    dimensionedScalar rho(transportProperties.lookup("rho"));

    // Reading specific heat capacity
    dimensionedScalar cps(transportProperties.lookup("cps"));
    dimensionedScalar cpl(transportProperties.lookup("cpl"));

    // Reading thermal conductivity
    dimensionedScalar lambdas(transportProperties.lookup("lambdas"));
    dimensionedScalar lambdal(transportProperties.lookup("lambdal"));

    // Reading kinematic viscosity
    dimensionedScalar mu0(transportProperties.lookup("mu"));
    dimensionedScalar muk(transportProperties.lookup("muk"));

    // Reading latent heat of fusion
    dimensionedScalar L(transportProperties.lookup("L"));

    // Reading melting temperature range
    dimensionedScalar Ts(transportProperties.lookup("Ts"));
    dimensionedScalar Tl(transportProperties.lookup("Tl"));
    
    dimensionedScalar Tmelt
    (
        "Tmelt", 
        (Tl+Ts)/scalar(2.0)
    );

    // Reading volume expansion factor
    dimensionedScalar beta(transportProperties.lookup("beta"));

    // Reading large D'arcy-type source term constant DCl
    dimensionedScalar DCl(transportProperties.lookup("DCl"));
    dimensionedScalar DCs(transportProperties.lookup("DCs"));
